## yadifa 3.0.6

=== CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2025, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

include(${CMAKE_SOURCE_DIR}/cmake/CheckCHeaders.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/CheckCompilerFlags.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/EURidToolbox.cmake)

read_version("3.0.6")

project(yadifa VERSION ${VERSION_TEXT} LANGUAGES C)

kvstatus("YADIFA version" "${VERSION_TEXT}")

if(WIN32)
set(BUILD_SHARED_LIBS OFF)
set(BUILD_STATIC_LIBS ON)
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /STACK:8388608")
add_definitions(-DMICROSOFT_WINDOWS_WINBASE_H_DEFINE_INTERLOCKED_CPLUSPLUS_OVERLOADS=0)
endif()

set(IGNORE_GNU_INSTALL_DIRS false CACHE BOOL "Ignore the rules of setting-up the installation paths")

if(NOT IGNORE_GNU_INSTALL_DIRS)
include(GNUInstallDirs)
endif()

set(CMAKE_C_STANDARD 11)
#set(CMAKE_C_STANDARD 23)

check_atomic_load()

include(${CMAKE_SOURCE_DIR}/cmake/FindOpenSSL.cmake)

set(CMAKE_VERBOSE_MAKEFILE ON)

check_self()
check_headers_files()
check_sockaddr_sin_len_field()
check_sockaddr_sin6_len_field()
check_c_compiler_flags()
check_memalign_issues()
if(UNIX)
check_gnu_source()
check_pthread_setname_np()
check_pthread_setaffinity_np()
check_pthread_spin_init()
check_gettid()
endif()
check_mremap()
check_timegm()
check_endianness()

# If we relase the cmake build, we cannot force the prefix to one of our owns.
#
#
# you must clear CMakeCache if you want to change this

#if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
#    set(CMAKE_INSTALL_PREFIX
#        "/registry/${PROJECT_NAME}-${PROJECT_VERSION}" CACHE PATH "${PROJECT_NAME} install prefix" FORCE
#    )
#endif()

################################################################################
#
#	PARAMETERS THAT CAN BE CHANGED
#
################################################################################

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

include(CTest) # must be included after EURidToolbox.cmake

set(YATEST_INCLUDE_DIRECTORY "${CMAKE_SOURCE_DIR}/tests")

# settings from subdirectories - START

set(PACKAGE "yadifa")
set(PACKAGE_VERSION "3.0.6")
set(VERSION "3.0.6")
set(PACKAGE_STRING "${PACKAGE} ${PACKAGE_VERSION}")
set(PACKAGE_BUGREPORT "bugreport@yadifa.eu")

set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE}-${PACKAGE_VERSION})
set(CPACK_SOURCE_IGNORE_FILES \.git.*;\.idea)
set(CPACK_SOURCE_GENERATOR "TGZ")

# please do not change these options
option_has(FILEPOOL_CACHE "DEVS: enable the user-level cache for the file pools" OFF)
option_has(DNSQ "DEVS: enable the code related to that project" OFF)
option_has_support(DROPALL "DEVS: Enable this test feature" OFF)
option_has_support(DYNCONF "DEVS: enable dynamic configuration" OFF)
option_has(EXPERIMENTAL "DEVS: Enable various experimental code" OFF)
option_has_support(MIRROR "DEVS: Enable this test feature" OFF)
option_has_support(NSEC "DEVS: enable NSEC support" ON)
option_has_support(NSEC3 "DEVS: enable NSEC3 support" ON)
option_has(RDTSC "DEVS: enable RDTSC usage for profiling" OFF)

set(NETWORK_INTERFACES_MAX 256)

mark_as_advanced(
        DNSQ
        DROPALL
        DYNCONF
        EXPERIMENTAL
        MIRROR
        NSEC
        NSEC3
        RDTSC
        )

option_has(DEBUG "Enable #if DEBUG code" OFF)

option_has_support(PRIMARY "Enable DNS primary code" ON)
option_has_support(DNSSEC "Enable DNSSEC support" ON)
option_has(CTRL "Enable remote control" ON)
option_has_support(NSID "Enable NSID support" ON)

option_has_support(ACL "Enable ACL support" ON)
option_has_support(RRL "Enable RRL support" ON)
option_has_support(TSIG "Enable TSIG support" ON)
option_has_support(DYNUPDATE "Enable dynamic update support" ON)
option_has_support(RRSIG_MANAGEMENT "Enable RRSIG verification and generation for zones" ON)
option_has_support(ZALLOC "Enable internal memory allocation support" ON)
option_has_support(ZALLOC_STATISTICS "Enable internal memory allocation statistics" OFF)
option_has_support(ZALLOC_DEBUG "Enable internal memory allocation debugging" OFF)
option_has_support(MMAP_DEBUG "Enable mmap debugging" OFF)
option_has_support(MALLOC_DEBUG "Enable heap memory allocation debugging" OFF)
option_has_support(LIBC_MALLOC_DEBUG "Enable libc malloc monitors" OFF)
option_has_support(BFD_DEBUG "Enable bfd debuging (symbol tables)" OFF)
option_has(QUERY_US_DEBUG "Measure query time in us" OFF)
option_has_support(MUTEX_DEBUG "Enable mutex debugging (insanely heavy)" OFF)
option_has_support(LOCK_DEBUG "Enable zone lock debugging (insanely heavy)" OFF)
option_has_support(TRACK_ZONES_DEBUG "Enable tracking of the instanciated zones for detecting potential leaks. Relatively cheap with a small (<100) amount of zones." OFF)
option_has(LOG_THREAD_ID "Enable a new column in the logs with an alphanumeric id consistent in the lowest 32 bits of the thread id sending the line" OFF)
option_has(LOG_THREAD_TAG "Enable a column with a 8 letters human-readable tag identifying a thread in each log line" ON)
option_has(LOG_PID "Enable a column with the pid in each line of log" ON)
option_has(FULL_ASCII7 "Enable acceptance of ASCII7 characters in DNS names (not recommended)" OFF)
option_has_support(ECDSA "Enable Elliptic Curve (ECDSA) support" ON)
if(NOT CMAKE_HOST_SYSTEM_NAME MATCHES "OpenBSD")
    option_has_support(EDDSA "Enable Edwards Curve (EDDSA) support" ON)
endif()
option(OPENSSL_DIRECTORY "Sets the installation directory of OPENSSL (default: autodetects)" "")

option_has_support(NON_AA_AXFR "Enable lenient acceptance of AXFR answer from primary that do not have AA bit set (Microsoft DNS)" OFF)
option_has(SYSTEMD_RESOLVED_AVOIDANCE "If set, yadifad will set do-not-listen to \"127.0.0.53 port 53\" by default (otherwise the list is empty)" OFF)
option_has(EVENT_DYNAMIC_MODULE "Enable Adds support for dynamically loaded module that gets events from yadifad and is allowed to fetch some information from the daemon (EXPERIMENTAL)" OFF)
option_has(TCL "Enable TCL support" OFF)
option_has(BUILD_TIMESTAMP "Set to ON to disable the build timestamp" OFF)
option_has(TCP_MANAGER "If set, the TCP manager will be enabled and used to handle TCP quotas" ON) # do NOT turn off
option_has(LOGGING_DISABLED "If set, the logging macros are no-operations. This is useful for coverage." OFF)
option_has_support(DNS_OVER_TLS "If set, yadifad will support DNS over TLS (experimental)" ON)
option_has_support(OQS "If set, yadifad will support experimental post-quantum-safe algorithms" OFF)

option_path(OPENSSL_DIRECTORY "Set to the path of openssl" "")

option_has(GCC_HARDENED "Adds build options for GCC" OFF)
option_has(SAVE_TEMPS "Keep the .s and .i files" OFF)

# some 'has_XXX' for YADIFA binary

#option_has(YADIFA              "controler for 'yadifad'"           ON) # HAS_CTRL is already defined
option_has(DNSSEC_TOOL         "replacement of BIND dnssec-tools"  ON)
option_has(DNS_CONFIG_CHECKER  "checks YADIFA config"             OFF)
option_has(YADIG               "replacement of BIND dig"           ON)

# still experimental stuff
# this is stuff needed when we have a WHOIS plugin
option_has(WHOIS               "for WHOIS plugin"                 OFF)
# this is stuff needed when we have a DNSQ plugin
option_has(DNSQ                "for DNSQ plugin"                  OFF)

option_set(TOOLS "Enable the tools" ON)

option_set(BUILD_SHARED_LIBS "Build shared libraries" ON)
option_set(BUILD_STATIC_LIBS "Build static libraries" OFF)
option_set(WITH_COVERAGE "Build with -fprofile-arcs and -ftest-coverage" OFF)

option_set(TIME64 "Build with _TIME_BITS=64" OFF)

kvstatus("OQS support" "${HAS_OQS_SUPPORT}")
if(${HAS_OQS_SUPPORT})
    include(${CMAKE_SOURCE_DIR}/cmake/FindOQS.cmake)
endif()

kvstatus("shared-build" "${BUILD_SHARED_LIBS}")
kvstatus("static-build" "${BUILD_STATIC_LIBS}")

#
# settings from subdirectories - END

# libraries can be compiled STATIC or SHARED

set(IS_DARWIN_OS                                 0)


if(NOT DEBUG)
    set(COMPILE_FOR_RELEASE                      1)
else()
    # you need to choose one of them, you can not switch on all of them
    # at the same time
    set(COMPILE_FOR_DEBUG                        1)
    set(COMPILE_FOR_PROFILE                      0)
endif()

set(CMAKE_HOST_UNIX                              1)

################################################################################
#
#       COLORIZE
#
################################################################################

if(NOT WIN32)
    message(STATUS "COLORIZE OUTPUT")
    string(ASCII 27 Esc)
    set(ColorReset  "${Esc}[m")
    set(ColorBold   "${Esc}[1m")
    set(Red         "${Esc}[31m")
    set(Green       "${Esc}[32m")
    set(Yellow      "${Esc}[33m")
    set(Blue        "${Esc}[34m")
    set(Magenta     "${Esc}[35m")
    set(Cyan        "${Esc}[36m")
    set(White       "${Esc}[37m")
    set(BoldRed     "${Esc}[1;31m")
    set(BoldGreen   "${Esc}[1;32m")
    set(BoldYellow  "${Esc}[1;33m")
    set(BoldBlue    "${Esc}[1;34m")
    set(BoldMagenta "${Esc}[1;35m")
    set(BoldCyan    "${Esc}[1;36m")
    set(BoldWhite   "${Esc}[1;37m")
endif()

###############################################################################
###############################################################################
##                                                                           ##
## DO NOT USE "PREFIX" AS FOR AUTOCONF/AUTOMAKE                              ##
##                                                                           ##
## DON'T : option(PREFIX "the installation prefix" ${CMAKE_INSTALL_PREFIX})  ##
##                                                                           ##
###############################################################################
###############################################################################

# Update back the options for GNUInstallDirs

if(IGNORE_GNU_INSTALL_DIRS)
set(CMAKE_INSTALL_FULL_SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "<prefix>/etc")
set(CMAKE_INSTALL_FULL_BINDIR "${CMAKE_INSTALL_PREFIX}/bin"  CACHE PATH "<prefix>/bin")
set(CMAKE_INSTALL_FULL_SBINDIR "${CMAKE_INSTALL_PREFIX}/sbin"  CACHE PATH "<prefix>/sbin")
set(CMAKE_INSTALL_FULL_LIBEXEC "${CMAKE_INSTALL_PREFIX}/libexec"  CACHE PATH "<prefix>/libexec")

=== lib/dnscore/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2025, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)
include(${CMAKE_SOURCE_DIR}/cmake/EURidToolbox.cmake)

project(dnscore LANGUAGES C)
set(CMAKE_C_STANDARD 11)
set(LIBRARY_SO_VERSION                       10.0.0)
set(LIBRARY_SO_MAJOR                             10)

set(PACKAGE "dnscore")

kvstatus("building" "${PACKAGE}")

add_definitions(-DDNSCORE_BUILD)

################################################################################
#
#       SOURCES
#
################################################################################

set(LIBRARY_SOURCE_PATH "src")
set(LIBRARY_HEADER_PATH "include/dnscore")
set(LIBRARY_CONFIG_FILE "dnscore_config.h")
set(LIBRARY_FEATURES_FILE "dnscore_config_features.h")
set(LIBRARY_FEATURES_PREFIX "DNSCORE_")

set(LIBRARY_SOURCES
    ${LIBRARY_SOURCE_PATH}/acl.c
    ${LIBRARY_SOURCE_PATH}/acl_config.c
    ${LIBRARY_SOURCE_PATH}/alarm.c
    #${LIBRARY_SOURCE_PATH}/allocator.c
    ${LIBRARY_SOURCE_PATH}/async.c
    ${LIBRARY_SOURCE_PATH}/base16.c
    ${LIBRARY_SOURCE_PATH}/base32.c
    ${LIBRARY_SOURCE_PATH}/base32hex.c
    ${LIBRARY_SOURCE_PATH}/base64.c
    ${LIBRARY_SOURCE_PATH}/basic_priority_queue.c
    ${LIBRARY_SOURCE_PATH}/buffer_input_stream.c
    ${LIBRARY_SOURCE_PATH}/buffer_output_stream.c
    ${LIBRARY_SOURCE_PATH}/buffered_file.c
    ${LIBRARY_SOURCE_PATH}/bytearray_input_stream.c
    ${LIBRARY_SOURCE_PATH}/bytearray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/bytezarray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/cache.c
    ${LIBRARY_SOURCE_PATH}/checked_output_stream.c
    ${LIBRARY_SOURCE_PATH}/circular_file.c
    ${LIBRARY_SOURCE_PATH}/clone_input_output_stream.c
    ${LIBRARY_SOURCE_PATH}/cmdline.c
    ${LIBRARY_SOURCE_PATH}/concat_input_stream.c
    ${LIBRARY_SOURCE_PATH}/config_cmdline.c
    ${LIBRARY_SOURCE_PATH}/config_file_reader.c
    ${LIBRARY_SOURCE_PATH}/config_key.c
    ${LIBRARY_SOURCE_PATH}/config_logger.c
    ${LIBRARY_SOURCE_PATH}/config_settings.c
    ${LIBRARY_SOURCE_PATH}/config_struct.c
    ${LIBRARY_SOURCE_PATH}/counter_output_stream.c
    ${LIBRARY_SOURCE_PATH}/crypto.c
    ${LIBRARY_SOURCE_PATH}/crc32.c
    ${LIBRARY_SOURCE_PATH}/debug.c
    ${LIBRARY_SOURCE_PATH}/debug_bench.c
    ${LIBRARY_SOURCE_PATH}/debug_bfd.c
    ${LIBRARY_SOURCE_PATH}/debug_malloc.c
    ${LIBRARY_SOURCE_PATH}/debug_mmap.c
    ${LIBRARY_SOURCE_PATH}/debug_stacktrace.c
    ${LIBRARY_SOURCE_PATH}/digest_rawdata.c
    ${LIBRARY_SOURCE_PATH}/dns_udp.c
    ${LIBRARY_SOURCE_PATH}/dns_message_verify_rrsig.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_dig.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_json.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_easyparse.c
    ${LIBRARY_SOURCE_PATH}/dns_resource_record.c
    ${LIBRARY_SOURCE_PATH}/dnscore.c
    ${LIBRARY_SOURCE_PATH}/dnscore_extension.c
    ${LIBRARY_SOURCE_PATH}/dnsformat.c
    ${LIBRARY_SOURCE_PATH}/dnskey.c
    ${LIBRARY_SOURCE_PATH}/dnskey_keyring.c
    ${LIBRARY_SOURCE_PATH}/dnskey_eddsa.c
    ${LIBRARY_SOURCE_PATH}/dnskey_signature.c
    ${LIBRARY_SOURCE_PATH}/dnsname.c
    ${LIBRARY_SOURCE_PATH}/empty_input_stream.c
    ${LIBRARY_SOURCE_PATH}/error_state.c
    ${LIBRARY_SOURCE_PATH}/fdtools.c
    ${LIBRARY_SOURCE_PATH}/file_input_stream.c
    ${LIBRARY_SOURCE_PATH}/file_mtime_set.c
    ${LIBRARY_SOURCE_PATH}/file_output_stream.c
    ${LIBRARY_SOURCE_PATH}/file_pool.c
    ${LIBRARY_SOURCE_PATH}/filesystem_file.c
    ${LIBRARY_SOURCE_PATH}/format.c
    ${LIBRARY_SOURCE_PATH}/hash.c
    ${LIBRARY_SOURCE_PATH}/hash_table_values.c
    ${LIBRARY_SOURCE_PATH}/host_address.c
    #${LIBRARY_SOURCE_PATH}/hsdllist.c
    ${LIBRARY_SOURCE_PATH}/http_chunk_output_stream.c
    ${LIBRARY_SOURCE_PATH}/identity.c
    ${LIBRARY_SOURCE_PATH}/initialise_state.c
    ${LIBRARY_SOURCE_PATH}/input_stream.c
    #${LIBRARY_SOURCE_PATH}/ipc.c
    ${LIBRARY_SOURCE_PATH}/json.c
    ${LIBRARY_SOURCE_PATH}/limited_input_stream.c
    ${LIBRARY_SOURCE_PATH}/limiter.c
    ${LIBRARY_SOURCE_PATH}/list_dl.c
    ${LIBRARY_SOURCE_PATH}/list_dl_nodata.c
    ${LIBRARY_SOURCE_PATH}/list_sl.c
    ${LIBRARY_SOURCE_PATH}/list_sl_debug.c
    ${LIBRARY_SOURCE_PATH}/logger_output_stream.c
    ${LIBRARY_SOURCE_PATH}/logger.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_file.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_stream.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_syslog.c
    ${LIBRARY_SOURCE_PATH}/logger_handle.c
    ${LIBRARY_SOURCE_PATH}/mapped_file.c
    ${LIBRARY_SOURCE_PATH}/dns_message.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer.c
    ${LIBRARY_SOURCE_PATH}/dns_message_update.c
    ${LIBRARY_SOURCE_PATH}/mt_output_stream.c
    ${LIBRARY_SOURCE_PATH}/mutex.c
    ${LIBRARY_SOURCE_PATH}/mutex_contention_monitor.c
    ${LIBRARY_SOURCE_PATH}/mutex_debug.c
    ${LIBRARY_SOURCE_PATH}/mutex_futex.c
    ${LIBRARY_SOURCE_PATH}/mutex_group.c
    ${LIBRARY_SOURCE_PATH}/mutex_mutex.c
    ${LIBRARY_SOURCE_PATH}/mutex_semaphore.c
    ${LIBRARY_SOURCE_PATH}/mutex_shared_group.c
    ${LIBRARY_SOURCE_PATH}/network.c
    ${LIBRARY_SOURCE_PATH}/name.c
    ${LIBRARY_SOURCE_PATH}/nsec3_hash.c
    ${LIBRARY_SOURCE_PATH}/output_stream.c
    ${LIBRARY_SOURCE_PATH}/pace.c
    ${LIBRARY_SOURCE_PATH}/dns_packet_reader.c
    ${LIBRARY_SOURCE_PATH}/dns_packet_writer.c
    ${LIBRARY_SOURCE_PATH}/parser.c
    ${LIBRARY_SOURCE_PATH}/parsing.c
    ${LIBRARY_SOURCE_PATH}/pcg_basic.c
    ${LIBRARY_SOURCE_PATH}/permut.c
    ${LIBRARY_SOURCE_PATH}/process.c
    ${LIBRARY_SOURCE_PATH}/pid.c
    ${LIBRARY_SOURCE_PATH}/pipe_stream.c
    ${LIBRARY_SOURCE_PATH}/pool.c
    ${LIBRARY_SOURCE_PATH}/ptr_treeset.c
    ${LIBRARY_SOURCE_PATH}/ptr_treeset_debug.c
    ${LIBRARY_SOURCE_PATH}/ptr_treemap.c
    ${LIBRARY_SOURCE_PATH}/ptr_treemap_debug.c
    ${LIBRARY_SOURCE_PATH}/ptr_vector.c
    ${LIBRARY_SOURCE_PATH}/pushback_input_stream.c
    ${LIBRARY_SOURCE_PATH}/queue_sl.c
    ${LIBRARY_SOURCE_PATH}/random.c
    ${LIBRARY_SOURCE_PATH}/rest_client.c
    ${LIBRARY_SOURCE_PATH}/rest_server.c
    ${LIBRARY_SOURCE_PATH}/rewind_input_stream.c
    ${LIBRARY_SOURCE_PATH}/rfc.c
    ${LIBRARY_SOURCE_PATH}/rndc.c
    ${LIBRARY_SOURCE_PATH}/serial.c
    ${LIBRARY_SOURCE_PATH}/server_setup.c
    ${LIBRARY_SOURCE_PATH}/service.c
    ${LIBRARY_SOURCE_PATH}/shared_heap.c
    ${LIBRARY_SOURCE_PATH}/shared_circular_buffer.c
    ${LIBRARY_SOURCE_PATH}/shared_heap_bytearray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/signals.c
    ${LIBRARY_SOURCE_PATH}/simple_http_server.c
    ${LIBRARY_SOURCE_PATH}/socket_server.c
    ${LIBRARY_SOURCE_PATH}/ssl_input_output_stream.c
    ${LIBRARY_SOURCE_PATH}/string_set.c
    ${LIBRARY_SOURCE_PATH}/sys_error.c
    ${LIBRARY_SOURCE_PATH}/sys_get_cpu_count.c
    ${LIBRARY_SOURCE_PATH}/tcp_io_stream.c
    ${LIBRARY_SOURCE_PATH}/tcp_manager2.c
    ${LIBRARY_SOURCE_PATH}/tcp_manager_channel_ssl_context.c
    ${LIBRARY_SOURCE_PATH}/thread_pool.c
    ${LIBRARY_SOURCE_PATH}/thread.c
    ${LIBRARY_SOURCE_PATH}/thread_setaffinity_macos.c
    ${LIBRARY_SOURCE_PATH}/thread_tag.c
    ${LIBRARY_SOURCE_PATH}/threaded_qsl_cw.c
    ${LIBRARY_SOURCE_PATH}/threaded_dll_cw.c
    ${LIBRARY_SOURCE_PATH}/threaded_nbrb.c
    ${LIBRARY_SOURCE_PATH}/threaded_queue_slg.c
    ${LIBRARY_SOURCE_PATH}/threaded_ringbuffer_cw.c
    ${LIBRARY_SOURCE_PATH}/timeformat.c
    ${LIBRARY_SOURCE_PATH}/timems.c
    ${LIBRARY_SOURCE_PATH}/tools.c
    ${LIBRARY_SOURCE_PATH}/typebitmap.c
    ${LIBRARY_SOURCE_PATH}/u32_treeset.c
    ${LIBRARY_SOURCE_PATH}/u64_treeset.c
    ${LIBRARY_SOURCE_PATH}/u64_treeset_debug.c
    ${LIBRARY_SOURCE_PATH}/u32_treemap.c
    ${LIBRARY_SOURCE_PATH}/u64_treemap.c
    ${LIBRARY_SOURCE_PATH}/uri.c
    ${LIBRARY_SOURCE_PATH}/utf8.c
    ${LIBRARY_SOURCE_PATH}/xfr_input_stream.c
    ${LIBRARY_SOURCE_PATH}/zalloc.c
    ${LIBRARY_SOURCE_PATH}/zone_reader_axfr.c
    ${LIBRARY_SOURCE_PATH}/zone_reader_text.c
)

if(NOT WIN32)
    if(OPENSSL_VERSION_MAJOR LESS 3)
        message("using libssl < 3.0 API")
        set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
            #${LIBRARY_SOURCE_PATH}/dnskey_dsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_ecdsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_rsa.c
            ${LIBRARY_SOURCE_PATH}/digest_sha1.c
            ${LIBRARY_SOURCE_PATH}/digest_sha256.c
            ${LIBRARY_SOURCE_PATH}/digest_sha384.c
            ${LIBRARY_SOURCE_PATH}/digest_sha512.c
            ${LIBRARY_SOURCE_PATH}/hmac_openssl.c)
    else()
        message("using libssl >= 3.0 API")
        set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
            ${LIBRARY_SOURCE_PATH}/dnskey_evp.c
            #${LIBRARY_SOURCE_PATH}/dnskey_evp_dsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_evp_ecdsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_evp_rsa.c
            ${LIBRARY_SOURCE_PATH}/digest_evp.c
            ${LIBRARY_SOURCE_PATH}/hmac_evp.c)
    endif()
    set(LIBRARY_SOURCES ${LIBRARY_SOURCES} ${LIBRARY_SOURCE_PATH}/digest_md5_internal.c)
else()
    message("using libssl >= 3.0 API")
    set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/dnskey_evp.c
        #${LIBRARY_SOURCE_PATH}/dnskey_evp_dsa.c
        ${LIBRARY_SOURCE_PATH}/dnskey_evp_ecdsa.c
        ${LIBRARY_SOURCE_PATH}/dnskey_evp_rsa.c
        ${LIBRARY_SOURCE_PATH}/digest_evp.c
        ${LIBRARY_SOURCE_PATH}/hmac_evp.c)
endif()

set(LIBRARY_HEADERS
    ${LIBRARY_HEADER_PATH}/acl.h
    ${LIBRARY_HEADER_PATH}/acl_config.h
    ${LIBRARY_HEADER_PATH}/alarm.h
    #${LIBRARY_HEADER_PATH}/allocator.h
    ${LIBRARY_HEADER_PATH}/async.h
    ${LIBRARY_HEADER_PATH}/avl.c.inc
    ${LIBRARY_HEADER_PATH}/avl.h.inc
    ${LIBRARY_HEADER_PATH}/base16.h
    ${LIBRARY_HEADER_PATH}/base32.h
    ${LIBRARY_HEADER_PATH}/base32hex.h
    ${LIBRARY_HEADER_PATH}/base64.h
    ${LIBRARY_HEADER_PATH}/basic_priority_queue.h
    ${LIBRARY_HEADER_PATH}/buffer_input_stream.h
    ${LIBRARY_HEADER_PATH}/buffer_output_stream.h
    ${LIBRARY_HEADER_PATH}/buffered_file.h
    ${LIBRARY_HEADER_PATH}/bytearray_input_stream.h
    ${LIBRARY_HEADER_PATH}/bytearray_output_stream.h
    ${LIBRARY_HEADER_PATH}/bytezarray_output_stream.h
    ${LIBRARY_HEADER_PATH}/cache.h
    ${LIBRARY_HEADER_PATH}/checked_output_stream.h
    ${LIBRARY_HEADER_PATH}/circular_file.h
    ${LIBRARY_HEADER_PATH}/clone_input_output_stream.h

=== lib/dnsdb/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2025, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)
project(dnsdb LANGUAGES C)

include(${CMAKE_SOURCE_DIR}/cmake/EURidToolbox.cmake)

set(CMAKE_C_STANDARD 11)
set(LIBRARY_SO_VERSION 10.0.0)
set(LIBRARY_SO_MAJOR 10)

set(PACKAGE "dnsdb")

kvstatus("building" "${PACKAGE}")

add_definitions(-DDNSDB_BUILD)

################################################################################
#
#       SOURCES
#
################################################################################

set(LIBRARY_SOURCE_PATH "src")
set(LIBRARY_HEADER_PATH "include/dnsdb")
set(LIBRARY_CONFIG_FILE "dnsdb_config.h")
set(LIBRARY_FEATURES_FILE "zdb_config_features.h")
set(LIBRARY_FEATURES_PREFIX "ZDB_")

set(LIBRARY_SOURCES
        ${LIBRARY_SOURCE_PATH}/avl.c
        ${LIBRARY_SOURCE_PATH}/dictionary.c
        ${LIBRARY_SOURCE_PATH}/dictionary_btree.c
        ${LIBRARY_SOURCE_PATH}/dictionary_htbt.c
        ${LIBRARY_SOURCE_PATH}/htable.c
        ${LIBRARY_SOURCE_PATH}/htbt.c
		${LIBRARY_SOURCE_PATH}/journal_cjf.c
        ${LIBRARY_SOURCE_PATH}/journal_cjf_idxt.c
        ${LIBRARY_SOURCE_PATH}/journal_cjf_page_cache.c
        ${LIBRARY_SOURCE_PATH}/journal_cjf_page_output_stream.c
        ${LIBRARY_SOURCE_PATH}/journal_cjf_page.c
		${LIBRARY_SOURCE_PATH}/journal_cjf_ro.c
        ${LIBRARY_SOURCE_PATH}/journal.c
        ${LIBRARY_SOURCE_PATH}/journal_ix.c
        ${LIBRARY_SOURCE_PATH}/journal_jnl.c
        ${LIBRARY_SOURCE_PATH}/xfr_copy.c

		${LIBRARY_SOURCE_PATH}/zdb_zone_resource_record.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_resource_record_set.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_resource_record_sets.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_resource_record_sets_collection.c

        ${LIBRARY_SOURCE_PATH}/zdb_zone_answer_axfr.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_answer_ixfr.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_arc.c
		#${LIBRARY_SOURCE_PATH}/zdb_zone_diff.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_dnssec.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_find.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_garbage.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_journal.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_lock.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_lock_monitor.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_path_provider.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_reader_filter.c
        ${LIBRARY_SOURCE_PATH}/zdb.c
        ${LIBRARY_SOURCE_PATH}/zdb_cache.c
        ${LIBRARY_SOURCE_PATH}/zdb_error.c
        ${LIBRARY_SOURCE_PATH}/zdb_icmtl.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append_nsec.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append_nsec3.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append_soa.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append_type_rrsigs.c
		${LIBRARY_SOURCE_PATH}/zdb_record.c
        ${LIBRARY_SOURCE_PATH}/zdb_rr_label.c
        ${LIBRARY_SOURCE_PATH}/zdb_sanitize.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_axfr_input_stream.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_label.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_label_iterator.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_label_iterator_ex.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_load.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_process.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_store_axfr.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_store_czf.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_write_text.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_write_unbound.c
)

set(LIBRARY_HEADERS
        ${LIBRARY_HEADER_PATH}/avl.h
        ${LIBRARY_HEADER_PATH}/btree.h
        ${LIBRARY_HEADER_PATH}/dictionary.h
        ${LIBRARY_HEADER_PATH}/dictionary_node.h
        ${LIBRARY_HEADER_PATH}/dnsname_zone_dict.h
        ${LIBRARY_HEADER_PATH}/dnsrdata.h
        ${LIBRARY_HEADER_PATH}/dnssec.h
        ${LIBRARY_HEADER_PATH}/dnssec_config.h
        ${LIBRARY_HEADER_PATH}/dnssec_keystore.h
        ${LIBRARY_HEADER_PATH}/htable.h
        ${LIBRARY_HEADER_PATH}/htbt.h
        ${LIBRARY_HEADER_PATH}/journal_cjf.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_common.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_idxt.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_page.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_page_cache.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_page_output_stream.h
        ${LIBRARY_HEADER_PATH}/journal.h
        ${LIBRARY_HEADER_PATH}/journal_ix.h
        ${LIBRARY_HEADER_PATH}/journal_jnl.h
        ${LIBRARY_HEADER_PATH}/chain_replay.h
        ${LIBRARY_HEADER_PATH}/nsec.h
        ${LIBRARY_HEADER_PATH}/nsec_chain_replay.h
        ${LIBRARY_HEADER_PATH}/nsec3.h
        ${LIBRARY_HEADER_PATH}/nsec3_collection.h
        ${LIBRARY_HEADER_PATH}/nsec3_chain_replay.h
        ${LIBRARY_HEADER_PATH}/nsec3_item.h
        ${LIBRARY_HEADER_PATH}/nsec3_load.h
        ${LIBRARY_HEADER_PATH}/nsec3_owner.h
        ${LIBRARY_HEADER_PATH}/nsec3_types.h
        ${LIBRARY_HEADER_PATH}/nsec3_zone.h
        ${LIBRARY_HEADER_PATH}/nsec_collection.h
        ${LIBRARY_HEADER_PATH}/nsec_common.h
        ${LIBRARY_HEADER_PATH}/rrsig.h
        ${LIBRARY_HEADER_PATH}/xfr_copy.h
        ${LIBRARY_HEADER_PATH}/zdb.h
        ${LIBRARY_HEADER_PATH}/zdb_config.h
        ${LIBRARY_HEADER_PATH}/zdb_error.h
        ${LIBRARY_HEADER_PATH}/zdb_icmtl.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append_nsec.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append_nsec3.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append_soa.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append_type_rrsigs.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_context.h
        ${LIBRARY_HEADER_PATH}/zdb_record.h
        ${LIBRARY_HEADER_PATH}/zdb_rr_label.h
        ${LIBRARY_HEADER_PATH}/zdb_sanitize.h
		${LIBRARY_HEADER_PATH}/zdb_ttlrdata.h
        ${LIBRARY_HEADER_PATH}/zdb_types.h
        ${LIBRARY_HEADER_PATH}/zdb_cache.h
        ${LIBRARY_HEADER_PATH}/zdb_zone.h
        ${LIBRARY_HEADER_PATH}/zdb_lock.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_arc.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_dnssec.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_find.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_garbage.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_journal.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_lock.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_lock_monitor.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_answer_axfr.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_answer_ixfr.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_maintenance.h
        ${LIBRARY_HEADER_PATH}/zdb_packed_ttlrdata.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_axfr_input_stream.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_label.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_label_iterator.h
		${LIBRARY_HEADER_PATH}/zdb_zone_label_iterator_ex.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_load.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_path_provider.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_process.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_reader_filter.h
		${LIBRARY_HEADER_PATH}/zdb_zone_resource_record.h
		${LIBRARY_HEADER_PATH}/zdb_zone_resource_record_set.h
		${LIBRARY_HEADER_PATH}/zdb_zone_resource_record_sets.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_write.h
        ${LIBRARY_HEADER_PATH}/nsec3_forall_label.h
)


kvstatus("HAS_DYNUPDATE_SUPPORT" "${HAS_DYNUPDATE_SUPPORT}")
if(HAS_DYNUPDATE_SUPPORT)
    set(LIBRARY_SOURCES
        ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/dynupdate_check_prerequisites.c
        ${LIBRARY_SOURCE_PATH}/dynupdate_diff.c
        ${LIBRARY_SOURCE_PATH}/dynupdate_diff_nochain.c
        ${LIBRARY_SOURCE_PATH}/dynupdate_diff_nsec.c
        ${LIBRARY_SOURCE_PATH}/dynupdate_diff_nsec3.c
		${LIBRARY_SOURCE_PATH}/dynupdate_message.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_maintenance.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_maintenance_rrsig.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_maintenance_nsec.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_maintenance_nsec3.c
	)
    set(LIBRARY_HEADERS
        ${LIBRARY_HEADERS}
	    ${LIBRARY_HEADER_PATH}/dynupdate.h
	    ${LIBRARY_HEADER_PATH}/dynupdate_diff.h
		${LIBRARY_HEADER_PATH}/dynupdate_message.h
    )
endif()

kvstatus("HAS_DNSSEC_SUPPORT" "${HAS_DNSSEC_SUPPORT}")
if(HAS_DNSSEC_SUPPORT)
		set(LIBRARY_SOURCES
        ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/dnssec.c
        ${LIBRARY_SOURCE_PATH}/dnssec_keystore.c
        ${LIBRARY_SOURCE_PATH}/nsec_common.c
        ${LIBRARY_SOURCE_PATH}/rrsig.c
        ${LIBRARY_SOURCE_PATH}/zdb_packed_ttlrdata.c
    )
endif()

kvstatus("HAS_NSEC3_SUPPORT" "${HAS_NSEC3_SUPPORT}")
if(HAS_NSEC3_SUPPORT)
		set(LIBRARY_SOURCES
        ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/nsec3.c
        ${LIBRARY_SOURCE_PATH}/nsec3_collection.c
        ${LIBRARY_SOURCE_PATH}/nsec3_item.c
        ${LIBRARY_SOURCE_PATH}/nsec3_chain_replay.c
        ${LIBRARY_SOURCE_PATH}/nsec3_load.c
        ${LIBRARY_SOURCE_PATH}/nsec3_owner.c
        ${LIBRARY_SOURCE_PATH}/nsec3_zone.c
        ${LIBRARY_SOURCE_PATH}/nsec3_forall_label.c
    )

		set(LIBRARY_HEADERS
        ${LIBRARY_HEADERS}
#        ${LIBRARY_HEADER_PATH}/nsec3.h
#        ${LIBRARY_HEADER_PATH}/nsec3_collection.h
#        ${LIBRARY_HEADER_PATH}/nsec3_hash.h
#        ${LIBRARY_HEADER_PATH}/nsec3_item.h
#        ${LIBRARY_HEADER_PATH}/nsec3_load.h
#        ${LIBRARY_HEADER_PATH}/nsec3_owner.h
#        ${LIBRARY_HEADER_PATH}/nsec3_types.h
#        ${LIBRARY_HEADER_PATH}/nsec3_zone.h
    )
endif()

if(HAS_NSEC_SUPPORT)
		set(LIBRARY_SOURCES
        ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/nsec.c
		${LIBRARY_SOURCE_PATH}/nsec_chain_replay.c
        ${LIBRARY_SOURCE_PATH}/nsec_collection.c
    )

		set(LIBRARY_HEADERS
        ${LIBRARY_HEADERS}
#        ${LIBRARY_HEADER_PATH}/nsec.h
#        ${LIBRARY_HEADER_PATH}/nsec_collection.h
#        ${LIBRARY_HEADER_PATH}/nsec_common.h
    )
endif()

# add itself as search path
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/include")

################################################################################
#
# Config & features
#
################################################################################

=== lib/dnscore/tests/mutex-test/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2025, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

cmake_path(GET CMAKE_CURRENT_SOURCE_DIR FILENAME NAME)
set(SOURCE_FILES main.c)

include_directories(BEFORE
                    "${YATEST_INCLUDE_DIRECTORY}"
                    "${CMAKE_SOURCE_DIR}/lib/dnscore/include"
                    "${CMAKE_BINARY_DIR}/lib/dnscore/include"
                    "${CMAKE_SOURCE_DIR}/lib/dnscore/tests/modules")


add_executable(${NAME} ${SOURCE_FILES})
target_coverage_test(${NAME})
target_link_libraries(${NAME} PUBLIC ${DNSCORELIB_NAME})

add_test(NAME "${NAME}-exclusion2_test"  COMMAND ${NAME} exclusion2_test)
add_test(NAME "${NAME}-exclusion4_test"  COMMAND ${NAME} exclusion4_test)
add_test(NAME "${NAME}-exclusion8_test"  COMMAND ${NAME} exclusion8_test)
add_test(NAME "${NAME}-exclusion_recursive2_test"  COMMAND ${NAME} exclusion_recursive2_test)
add_test(NAME "${NAME}-exclusion_recursive4_test"  COMMAND ${NAME} exclusion_recursive4_test)
add_test(NAME "${NAME}-exclusion_recursive8_test"  COMMAND ${NAME} exclusion_recursive8_test)
add_test(NAME "${NAME}-exclusion_group2_test"  COMMAND ${NAME} exclusion_group2_test)
add_test(NAME "${NAME}-exclusion_group4_test"  COMMAND ${NAME} exclusion_group4_test)
add_test(NAME "${NAME}-exclusion_group8_test"  COMMAND ${NAME} exclusion_group8_test)
add_test(NAME "${NAME}-exclusion_shared_mutex2_test"  COMMAND ${NAME} exclusion_shared_mutex2_test)
add_test(NAME "${NAME}-exclusion_shared_mutex4_test"  COMMAND ${NAME} exclusion_shared_mutex4_test)
add_test(NAME "${NAME}-exclusion_shared_mutex8_test"  COMMAND ${NAME} exclusion_shared_mutex8_test)
add_test(NAME "${NAME}-exclusion_shared_mutex_try2_test"  COMMAND ${NAME} exclusion_shared_mutex_try2_test)
add_test(NAME "${NAME}-exclusion_shared_mutex_recursive2_test"  COMMAND ${NAME} exclusion_shared_mutex_recursive2_test)
add_test(NAME "${NAME}-exclusion_shared_mutex_recursive4_test"  COMMAND ${NAME} exclusion_shared_mutex_recursive4_test)
add_test(NAME "${NAME}-exclusion_shared_mutex_recursive8_test"  COMMAND ${NAME} exclusion_shared_mutex_recursive8_test)
add_test(NAME "${NAME}-shared_group_mutex_transferlock_test"  COMMAND ${NAME} shared_group_mutex_transferlock_test)
add_test(NAME "${NAME}-speed_test"  COMMAND ${NAME} speed_test)
add_test(NAME "${NAME}-mutex_debug_test"  COMMAND ${NAME} mutex_debug_test)
add_test(NAME "${NAME}-mutex_futex_test"  COMMAND ${NAME} mutex_futex_test)
add_test(NAME "${NAME}-mutex_semaphore_test"  COMMAND ${NAME} mutex_semaphore_test)
add_test(NAME "${NAME}-mutex_semaphore_shared_mem_test"  COMMAND ${NAME} mutex_semaphore_shared_mem_test)

=== debian/changelog ===
yadifa (3.0.6-1) unstable; urgency=medium

  [ Markus Schade ]
  * New upstream version 3.0.6
  * Drop libatomic patch
  * Enable zonesign and keygen module for yadifa tool

  [ Luca Boccassi ]
  * Install and use sysusers.d config files
  * Do not start the service on install, same as the init script
  * Stop deleting system user on purge
  * Always use invoke-rc.d when stopping on remove

 -- Markus Schade <markus.schade@gmail.com>  Wed, 18 Feb 2026 17:52:29 +0000

=== debian/control ===
Source: yadifa
Section: net
Priority: optional
Maintainer: Markus Schade <markus.schade@gmail.com>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-installsysusers,
 libssl-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://www.yadifa.eu
Vcs-Git: https://salsa.debian.org/dns-team/yadifa.git
Vcs-Browser: https://salsa.debian.org/dns-team/yadifa

Package: yadifa
Architecture: any
Depends:
 debconf,
 netbase,
 ${misc:Depends},
 ${shlibs:Depends}
Description: Internet Domain Name Server
 ${Description}
 .
 This package provides the server and related configuration files.

Package: libyadifa-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: development libraries and header files for YADIFA
 ${Description}
 .
 This package contains the header files and static libraries needed for
 developing applications for YADIFA. It is currently only used by YADIFA
 itself and should not be considered stable.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_BUILD_MAINT_OPTIONS = hardening=+all
DEB_CFLAGS_MAINT_APPEND = -Wall -Wextra
DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -g
DPKG_EXPORT_BUILDFLAGS = 1
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

-include /usr/share/dpkg/buildflags.mk

ifeq ($(DEB_HOST_ARCH_OS),hurd)
  WITH_MESSAGES = --disable-messages
else
  WITH_MESSAGES = --enable-messages
endif

DEB_CONFIGURE_EXTRA_ARGS :=			\
	--with-tools				\
	--enable-rrl				\
	--enable-nsid				\
	--enable-ctrl				\
	--enable-zonesign			\
	--enable-keygen				\
	--enable-dynamic-provisioning		\
	--disable-build-timestamp		\
	--enable-systemd-resolved-avoidance	\
	$(WITH_MESSAGES)			\
	$(NULL)

%:
	dh $@

override_dh_clean:
	dh_clean
	rm -f debian/substvars

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_ARGS)

override_dh_installinit:
	dh_installinit -a --no-start

override_dh_installsystemd:
	dh_installsystemd --no-start

override_dh_installman:
	dh_installman --language=C

override_dh_gencontrol:
	for i in $$(sed -n '/^Package:/s/^.* //p' debian/control); do cat debian/vars.in >> debian/$$i.substvars; done
	cat debian/vars.in >> debian/substvars
	dh_gencontrol
